#include <stdio.h>
#include <string.h>
#include <elwix.h>
#include <netinet/in.h>


int
main(int argc, char **argv)
{
	sockaddr_t addr = { 0 };
	ait_val_t v, *val = NULL;
	struct in_addr a;
	netaddr_t n, *n0;
	inaddr_t t;

	a.s_addr = E_CIDRMASK(8);
	printf("/8 = %08X %08x\n", a.s_addr, htonl(a.s_addr));
	a.s_addr = E_CIDRMASK(24);
	printf("/24 = %08X %08x\n", a.s_addr, htonl(a.s_addr));
	a.s_addr = E_CIDRMASK(26);
	printf("/26 = %08X %08x\n", a.s_addr, htonl(a.s_addr));
	a.s_addr = E_CIDRMASK(30);
	printf("/30 = %08X %08x\n", a.s_addr, htonl(a.s_addr));

	memset(&n, 0, sizeof n);
	n.addr.sin.sin_family = AF_INET;
	n.addr.sin.sin_addr.s_addr = inet_addr("10.10.10.1");
	n.mask.in.s_addr = E_CIDRMASK(24);

	t.in.s_addr = inet_addr("10.10.10.42");
	printf("10.10.10.42 is in network 10.10.10.0/24? %d\n", e_innet(&n, &t));
	t.in.s_addr = inet_addr("10.10.0.42");
	printf("10.10.0.42 is in network 10.10.10.0/24? %d\n", e_innet(&n, &t));
	t.in.s_addr = inet_addr("172.16.0.42");
	printf("172.16.0.42 is in network 10.10.10.0/24? %d\n", e_innet(&n, &t));

	n0 = e_getnet("1.1.1.1/12");
	if (n0) {
		printf("addr=%s/%x\n", inet_ntoa(n0->addr.sin.sin_addr), ntohl(n0->mask.in.s_addr));
		e_free(n0);
	}
	n0 = e_getnet("2.2.2.2");
	if (n0) {
		printf("addr=%s/%x\n", inet_ntoa(n0->addr.sin.sin_addr), ntohl(n0->mask.in.s_addr));
		e_free(n0);
	}
	n0 = e_getnet("elwix.org/29");
	if (n0) {
		printf("addr=%s/%x\n", inet_ntoa(n0->addr.sin.sin_addr), ntohl(n0->mask.in.s_addr));
		e_free(n0);
	}

	if (argc < 2)
		return 0;

	AIT_SET_DATA(val, "shits hit the fan! --- shits with Merudia ...\n", 47);
	printf("GET DATA = %p %s t=%d l=%d\n", val, AIT_GET_DATA(val), AIT_TYPE(val), AIT_LEN(val));
	AIT_SET_DATA(val, argv[1], strlen(argv[1]) + 1);

	AIT_SET_DATA(val, argv[1], strlen(argv[1]) + 1);
	printf("GET DATA = %p %s t=%d l=%d\n", val, AIT_GET_DATA(val), AIT_TYPE(val), AIT_LEN(val));
	ait_freeVar(&val);
	ait_freeVar(&val);

	if (!e_gethostbyname(argv[1], 1234, &addr)) {
		printf("Error:: #%d - %s\n", elwix_GetErrno(), elwix_GetError());
		return 1;
	}

	if (!e_n2addr(&addr, &v)) {
		printf("Error:: #%d - %s\n", elwix_GetErrno(), elwix_GetError());
		return 2;
	}

	printf("Address is %s port is %u\n", AIT_GET_STR(&v), e_n2port(&addr));

	AIT_FREE_VAL(&v);
	return 0;
}
